import java.util.*;
import java.io.*;
/*
* Rozwiazanie w Javie problemu F z finalow ACM ICPC 2006
* (Problem "Zegar" = "Building a Clock")
* Autorzy: Wojciech Kazana i Tomasz Kazana
*/


public class Zegar {
static public int N, R;
static public int[] tab = new int[256];
static public Vector[] wzorce;
static public int numer;
static public int kije, kolka;
static public String wyn, wyn1, wyn2;

static public String perm;

private static boolean  next_permutation() {
	int cur = perm.length()-2;
	while (cur>=0 && perm.charAt(cur)>perm.charAt(cur+1)) cur--;
	if (cur==-1) return false;
	char[] pom = perm.toCharArray();
	int cur2 = pom.length-1;
	while (pom[cur2]<pom[cur]) cur2--;
	char t = pom[cur];
	pom[cur]=pom[cur2]; 
	pom[cur2]=t;
	for (int i=cur+1; pom.length-i+cur>=i; ++i) {
	t = pom[i];
	pom[i]=pom[pom.length-i+cur];
	pom[pom.length-i+cur]=t;
	}
	perm = new String(pom);
	return true;
}

private static int gcd (int a, int b) {
if (b > 0) return gcd(b, a%b);
return a;
 };

private static void wylicz_wzorce() {
Vector<Integer> a = new Vector(); a.add(1);
wzorce[1].add(a);
Vector<Integer> b = new Vector(); b.add(1); b.add(1);
wzorce[2].add(b);
for(int i=3;i<=6;++i) {
        for (int j = 0; j < wzorce[i-2].size(); ++j) {
		b = new Vector((Vector)(wzorce[i-2].elementAt(j)));
                wzorce[i].add(b);
                ((Vector)(wzorce[i].elementAt(wzorce[i].size()-1))).add(2);
        }
        for (int j = 0; j < wzorce[i-1].size(); ++j) {
                b = new Vector((Vector)(wzorce[i-1].elementAt(j)));
		wzorce[i].add(b);
                ((Vector)(wzorce[i].elementAt(wzorce[i].size()-1))).add(1);
        }
        }
}

private static void probuj(Vector<String> dane) {
int m = -1, h = -1;
int li = R;
int mn = 1;
if (li == 2 && mn == 1) h = 0;
if (li == 24&& mn == 1) m = 0;
for(int k=1;k<dane.size();++k) {
                   int t1 = tab[dane.elementAt(k-1).charAt(dane.elementAt(k-1).length()-1)];
                   int t2 = tab[dane.elementAt(k).charAt(0)];
                   li *= -t1;
                   mn *= t2;
                   int skr = gcd(Math.abs(li),Math.abs(mn));
                   li /= skr; mn /= skr;
                   if (h == -1 && li == 2 && mn == 1) h = k;
                   if (m == -1 && li == 24&& mn == 1) m = k;
                   }
if (m == -1 || h == -1) return;
int pr = Math.max(h,m) + 1;
if (pr > kije) return;
int kol = 1;
for (int i=0;i<pr-1;++i) kol += dane.elementAt(i).length();
if (kije == pr && kol > kolka) return;
String tym = "";
for (int i=0;i<m;++i) tym += dane.elementAt(i);
if (m!=0) tym += dane.elementAt(m).charAt(0);
for (int i=0;i<h;++i) tym += dane.elementAt(i);
if (h!=0) tym += dane.elementAt(h).charAt(0);
if (kije == pr && kol == kolka && tym.compareTo(wyn) > 0) return;
kije = pr;
kolka = kol;
wyn = tym;
wyn1 = "*";
wyn2 = "*";
for (int i=0;i<m;++i) wyn1 += dane.elementAt(i) + '-';
if (m!=0) wyn1 += dane.elementAt(m).charAt(0);
for (int i=0;i<h;++i) wyn2 += dane.elementAt(i) + '-';
if (h!=0) wyn2 += dane.elementAt(h).charAt(0);
}

private static void probuj(Vector<String> dane1, Vector<String> dane2, int wsp) {
int m = -1, h = -1;
int li = R;
int mn = 1;
if (li == 2 && mn == 1) h = 0;
if (li == 24&& mn == 1) m = 0;
if (m == -1)
for(int k=1;k<dane1.size();++k) {
                   int t1 = tab[dane1.elementAt(k-1).charAt(dane1.elementAt(k-1).length()-1)];
                   int t2 = tab[dane1.elementAt(k).charAt(0)];
                   li *= -t1;
                   mn *= t2;
                   int skr = gcd(Math.abs(li),Math.abs(mn));
                   li /= skr; mn /= skr;
                   if (li == 24 && mn == 1) {
                         m = k;
                         break;
                         };
                   }
if (m == -1) return;
li = R;
mn = 1;
if (h == -1)
for(int k=1;k<dane2.size();++k) {
                   int t1 = tab[dane2.elementAt(k-1).charAt(dane2.elementAt(k-1).length()-1)];
                   int t2 = tab[dane2.elementAt(k).charAt(0)];
                   li *= -t1;
                   mn *= t2;
                   int skr = gcd(Math.abs(li),Math.abs(mn));
                   li /= skr; mn /= skr;
                   if (li == 2 && mn == 1) {
                         h = k;
                         break;
                         };
                   }
if (h == -1) return;
if (m < wsp || h < wsp) return;
int pr = h+m+2 - wsp;
if (pr > kije) return;
int kol = 2;
for (int i = wsp; i < m-1; ++i) kol += dane1.elementAt(i).length();
for (int i=0;i<h-1;++i) kol += dane2.elementAt(i).length();
if (kije == pr && kol > kolka) return;
String tym = "";
for (int i=0;i<m;++i) tym += dane1.elementAt(i);
tym += dane1.elementAt(m).charAt(0);
for (int i=0;i<h;++i) tym += dane2.elementAt(i);
tym += dane2.elementAt(h).charAt(0);
if (kije == pr && kol == kolka && tym.compareTo(wyn) > 0) return;
kije = pr;
kolka = kol;
wyn = tym;
wyn1 = wyn2 = "*";
for (int i=0;i<m;++i) wyn1 += dane1.elementAt(i) + '-';
wyn1 += dane1.elementAt(m).charAt(0);
for (int i=0;i<h;++i) wyn2 += dane2.elementAt(i) + '-';
wyn2 += dane2.elementAt(h).charAt(0);
}

private static void sprawdz(String s, int k) {
Vector<Integer> wzor = (Vector)(wzorce[N].elementAt(k));
Vector<String> dane = new Vector(); dane.setSize(wzor.size());
for (int i = 0; i < wzor.size(); ++i) dane.set(i,"");
Vector<String> dane2,dane1;
int poz = 0;
for (int i=0;i<dane.size();++i) for (int j=0;j<wzor.elementAt(i);++j) 
     dane.set(i,dane.elementAt(i)+s.charAt(poz++));
probuj(dane);
for(int i=1;i<wzor.size()-1;++i) {
        if (wzor.elementAt(i)==2) continue;
        for (int j=0;j<i-1;++j) {
                 dane1 = new Vector(dane); dane1.setSize(i);
                 dane2 = new Vector(dane); dane2.setSize(j);
                 String ss = "";
                 if (j != 0) ss += dane.elementAt(j).charAt(0);
                 ss += dane.elementAt(i).charAt(0);
                 dane2.add(ss);
                 for(int t=i+1;t<wzor.size();++t) dane2.add(new String(dane.elementAt(t)));
                 probuj(dane1, dane2, j+1);
                 }
        }

}

private static void pisz_wynik() {
System.out.print("Trial " + numer);
if (kije == 1000) {
         System.out.print(" IS IMPOSSIBLE\n\n");
         return;
         };     
System.out.print("\n");
System.out.print("Minutes: " + wyn1 + "\n");
System.out.print("Hours:   " + wyn2 + "\n\n");
};

public static void main(String[] args) throws IOException {
BufferedReader bufReader = new BufferedReader(new InputStreamReader(System.in));
wzorce = new Vector[7];
for (int i=0;i<7;++i) wzorce[i] = new Vector();
wylicz_wzorce(); 
char c;
int t;
StringTokenizer st = new StringTokenizer(bufReader.readLine());
N = Integer.parseInt(st.nextToken());
while (N>0) {
      numer++;
      kije = 1000;
      String s = "";
      R = Integer.parseInt(st.nextToken());
      for (int i=0;i<N;++i) {
               c = (st.nextToken()).charAt(0);
	       t = Integer.parseInt(st.nextToken());
               tab[c] = t;
               s += c;
               }
      char[] d = s.toCharArray();
      Arrays.sort(d);
      perm = new String(d);
      do {
      for (int i=0;i<wzorce[N].size();++i)
      sprawdz(perm,i);
      } while(next_permutation());
      pisz_wynik();
      st = new StringTokenizer(bufReader.readLine()); 
      N = Integer.parseInt(st.nextToken());
      }
};


}
