#include <stdio.h>
#include <vector>
#include <map>
#include <algorithm>
#include <queue>
#include <iostream>
#include <stdio.h>
using namespace std;
#define VI vector < int >
#define VC vector < char >
#define EVERY(c) (c).begin(), (c).end()
#define PB push_back
#define REP(i,n) for (int i = 0; i < (n); ++i)
#define VVI vector < VI >
#define VS vector <string>

/*
* Rozwiazanie w C++ problemu F z finalow ACM ICPC 2006
* (Problem "Zegar" = "Building a Clock")
* Autorzy: Tomasz Kazana i Wojciech Kazana
*/

int gcd (int a, int b) {return b ? gcd(b, a%b) : a; };

int N, R;
int tab[256];
VVI wzorce[7];
int numer;
int kije, kolka;
string wyn, wyn1, wyn2;

void wylicz_wzorce() {
VI a; a.PB(1);
wzorce[0].resize(1);
wzorce[1].PB(a);
a.PB(1);
wzorce[2].PB(a);
for(int i=3;i<=6;++i) {
        REP(j,wzorce[i-2].size()) {
                                  wzorce[i].PB(wzorce[i-2][j]);
                                  wzorce[i][wzorce[i].size()-1].PB(2);
        }
        REP(j,wzorce[i-1].size()) {
                                  wzorce[i].PB(wzorce[i-1][j]);
                                  wzorce[i][wzorce[i].size()-1].PB(1);
        }
        }
}

void probuj(VS &dane) {
int m = -1, h = -1;
int li = R;
int mn = 1;
if (li == 2 && mn == 1) h = 0;
if (li == 24&& mn == 1) m = 0;
for(int k=1;k<dane.size();++k) {
                   int t1 = tab[int((unsigned char)(*(dane[k-1].end() - 1)))];
                   int t2 = tab[int((unsigned char)(dane[k][0]))];
                   li *= -t1;
                   mn *= t2;
                   int skr = gcd(abs(li),abs(mn));
                   li /= skr; mn /= skr;
                   if (h == -1 && li == 2 && mn == 1) h = k;
                   if (m == -1 && li == 24&& mn == 1) m = k;
                   }
if (m == -1 || h == -1) return;
int pr = max(h,m) + 1;
if (pr > kije) return;
int kol = 1;
REP(i,pr-1) kol += dane[i].size();
if (kije == pr && kol > kolka) return;
string tym = "";
REP(i,m) tym += dane[i];
if (m) tym += dane[m][0];
REP(i,h) tym += dane[i];
if (h) tym += dane[h][0];
if (kije == pr && kol == kolka && tym > wyn) return;
kije = pr;
kolka = kol;
wyn = tym;
wyn1 = wyn2 = "*";
REP(i,m) wyn1 += dane[i] + '-';
if (m) wyn1 += dane[m][0];
REP(i,h) wyn2 += dane[i] + '-';
if (h) wyn2 += dane[h][0];
}

void probuj(VS &dane1, VS &dane2, int wsp) {
int m = -1, h = -1;
int li = R;
int mn = 1;
if (li == 2 && mn == 1) h = 0;
if (li == 24&& mn == 1) m = 0;
if (m == -1)
for(int k=1;k<dane1.size();++k) {
                   int t1 = tab[int((unsigned char)(*(dane1[k-1].end() - 1)))];
                   int t2 = tab[int((unsigned char)(dane1[k][0]))];
                   li *= -t1;
                   mn *= t2;
                   int skr = gcd(abs(li),abs(mn));
                   li /= skr; mn /= skr;
                   if (li == 24 && mn == 1) {
                         m = k;
                         break;
                         };
                   }
if (m == -1) return;
li = R;
mn = 1;
if (h == -1)
for(int k=1;k<dane2.size();++k) {
                   int t1 = tab[int((unsigned char)(*(dane2[k-1].end() - 1)))];
                   int t2 = tab[int((unsigned char)(dane2[k][0]))];
                   li *= -t1;
                   mn *= t2;
                   int skr = gcd(abs(li),abs(mn));
                   li /= skr; mn /= skr;
                   if (li == 2 && mn == 1) {
                         h = k;
                         break;
                         };
                   }
if (h == -1) return;
if (m < wsp || h < wsp) return;
int pr = h+m+2 - wsp;
if (pr > kije) return;
int kol = 2;
for (int i = wsp; i < m-1; ++i) kol += dane1[i].size();
REP(i,h-1) kol += dane2[i].size();
if (kije == pr && kol > kolka) return;
string tym = "";
REP(i,m) tym += dane1[i];
tym += dane1[m][0];
REP(i,h) tym += dane2[i];
tym += dane2[h][0];
if (kije == pr && kol == kolka && tym > wyn) return;
kije = pr;
kolka = kol;
wyn = tym;
wyn1 = wyn2 = "*";
REP(i,m) wyn1 += dane1[i] + '-';
wyn1 += dane1[m][0];
REP(i,h) wyn2 += dane2[i] + '-';
wyn2 += dane2[h][0];
}

void sprawdz(string &s, int k) {
VI &wzor = wzorce[N][k];
VS dane; dane.resize(wzor.size());
VS dane2,dane1;
int poz = 0;
REP(i,dane.size()) REP(j,wzor[i]) dane[i].PB(s[poz++]);
probuj(dane);
for(int i=1;i<wzor.size()-1;++i) {
        if (wzor[i]==2) continue;
        REP(j,i-1) {
                 dane1 = dane; dane1.resize(i);
                 dane2 = dane; dane2.resize(j);
                 string ss = "";
                 if (j != 0) ss += dane[j][0];
                 ss += dane[i][0];
                 dane2.PB(ss);
                 for(int k=i+1;k<wzor.size();++k) dane2.PB(dane[k]);
                 probuj(dane1, dane2, j+1);
                 }
        }

}

void pisz_wynik() {
printf("Trial %d", numer);
if (kije == 1000) {
         printf(" IS IMPOSSIBLE\n\n");
         return;
         };     
printf("\n");
printf("Minutes: %s\n", wyn1.c_str());
printf("Hours:   %s\n\n", wyn2.c_str());
};

int main() {  
wylicz_wzorce(); 
unsigned char c;
int t;
scanf("%d", &N);
while (N>0) {
      numer++;
      kije = 1000;
      string s = "";
      scanf("%d", &R);
      REP(i,N) {
               c = getchar();
               c = getchar();
               scanf("%d", &t);
               tab[c] = t;
               s += c;
               }
      sort(EVERY(s));
      do {
      REP(i,wzorce[N].size())
      sprawdz(s,i);
      } while(next_permutation(EVERY(s)));
      pisz_wynik();
      scanf("%d", &N);
      }
return 0;  
};
